package at.jku.ssw.pi.sort.impl;

import java.util.Comparator;

import at.jku.ssw.pi.sort.Sorter;

/**
 * A simple sorting algorithm that builds the sorted array one item at a time.
 */
@SuppressWarnings({ "rawtypes", "unchecked" })
public class InsertionSort extends Sorter {

	/** Sorts the array <code>items</code> of comparable objects. */
	public Object[] sort(Object[] data, Comparator cmp) {
		for (int sorted = 1; sorted < data.length; sorted++) {
			Object val = data[sorted];
			for (int insertPos = 0; insertPos < sorted; insertPos++) {
				if (cmp.compare(val, data[insertPos]) < 0) {
					System.arraycopy(data, insertPos, data, insertPos + 1, sorted - insertPos);
					data[insertPos] = val;
					break;
				}
			}
		}
		return data;
	}

}